<?php

namespace Cli;

use Cli\Assets\Console;
use Cli\Collection\CommandsCollection;

class Factory
{
    use Console;

    /**
     * @var array
     */
    private $argv;

    /**
     * Factory constructor.
     */
    public function __construct()
    {
        global $argv;
        $this->argv = $argv;
    }

    /**
     *
     */
    public function handle()
    {
        if(!isset($this->argv[1])) {
            $this->terminate("Enter command to continue");
        }

        $command = $this->argv[1];

        if(!CommandsCollection::exists($command)) {
            $this->terminate(sprintf("Command '%s' does not exist", $command));
        }

        $executor = CommandsCollection::get($command);
        $executor->handle();
    }

}