<?php

namespace Runtime\Factory;

use ReflectionFunction;
use ReflectionException;
use Runtime\Exceptions\ExceptionHandler;

class AppFactory {

    /**
     * @return array
     */
    protected function getHelperFunctions()
    {
        $result = [];

        $functions = get_defined_functions()['user'];

        try {
            foreach ($functions as $function) {
                $refl = new ReflectionFunction($function);

                if(endsWith($refl->getFileName(), 'helpers.php')) {
                    $result[] = $function;
                }
            }

        }
        catch (ReflectionException $e) {
            ExceptionHandler::make($e);
        }

        return $result;
    }

}